//-- extract ---------------//
//-- ||         ----------//
//-- xetract -    --------//
//--  |  |   ---    ------//
//-- xatrect -----    ----//
//--   |  |  -#049--    --//
//-- xacrett ---------------//

// xacrett.cpp
// @xacrett̎vłB
// @e한[`Ăяo܂B

/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/

// K{wb_
#include "stdafx.h"
#include "kiutil.h"
#include "resource.h"
#if _MSC_VER >= 1300
extern "C" { int _afxForceEXCLUDE; }
#endif

// [`
#include "Tool.h"

#include "LzhTool.h"
#include "ZipTool.h"
#include "ArjTool.h"
#include "RarTool.h"
#include "AceTool.h"
#include "TarTool.h"
#include "GzTool.h"
#include "Bz2Tool.h"
#include "CompressZTool.h"
#include "BgaTool.h"
#include "JakTool.h"
#include "IshTool.h"
#include "MimeTool.h"
#include "UnixDecoderTool.h"
#include "HqxTool.h"
#include "MSCompressTool.h"
#include "ZooTool.h"
#include "ArcTool.h"
#include "FrzTool.h"
#include "PackzTool.h"
#include "CompactCTool.h"
#include "BelTool.h"
#include "ArgTool.h"
#include "CptTool.h"
#include "ImpTool.h"
#include "PitTool.h"
#include "QPakTool.h"
#include "SplTool.h"
#include "BooTool.h"
#include "AtoBTool.h"
#include "SharTool.h"
#include "FishTool.h"
#include "RezTool.h"
#include "JamTool.h"
#include "AsdTool.h"
#include "ArTool.h"
#include "CpioTool.h"
#include "ZacTool.h"
#include "MacBinTool.h"
#include "DzTool.h"
//#include "PmdTool.h"
#include "YncTool.h"
#include "DmgTool.h"

#include "Yz1Tool.h"
#include "CabTool.h"
#include "GcaTool.h"
#include "IsTool.h"

// O[oϐ
static CTool* g_pToolList = NULL;
static char   g_DestDir[MAX_PATH];
static bool   g_bOpen, g_bMake, g_bDlg;

static int    g_nError[3] = {0,0,0};
enum { NOT_A_FILE, UNSUPPORTED, FAILED };

#define DATALOADSIZE (65536*4)
static unsigned char* g_pWorkSpace = NULL;

/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/

// ݒʌĂяocƂƊiDA /////////////////////////////
// o͐fBNgIԃ_CAOoB /////////////////////

static int CALLBACK OpenFolderProc
			( HWND wnd, UINT msg, LPARAM lp, LPARAM select )
{
	if( msg==BFFM_INITIALIZED && select!=0 )
	{
		SendMessage( wnd, BFFM_SETSELECTION, TRUE, select );
		kiutil::wndFront( wnd );
	}
	return 0;
}

static bool Configuration( char* dirname )
{
	// \̂Set!
	BROWSEINFO bi;
	memset( &bi,0,sizeof(bi) );
	bi.pszDisplayName	= dirname;
	bi.lpszTitle		= "Please Choose A Destination Directory.";
	bi.ulFlags			= BIF_RETURNONLYFSDIRS | BIF_DONTGOBELOWDOMAIN;
	bi.lpfn				= OpenFolderProc;
	bi.lParam			= (LPARAM)dirname;

	// Ăяo
	ITEMIDLIST* id = SHBrowseForFolder( &bi );
	if( id==NULL )
		return false;
	SHGetPathFromIDList( id,dirname );

	// 
	IMalloc* pMalloc;
	SHGetMalloc( &pMalloc );
	pMalloc->Free( id );
	pMalloc->Release();
	return true;
}

// ShiftNƂ́A //////////////////////////////////////////////////
// [`IʗpCallBack֐ /////////////////////////////////////

static BOOL CALLBACK TypeProc( HWND dlg,UINT msg,WPARAM wp,LPARAM lp )
{
	switch( msg )
	{
	case WM_INITDIALOG:
		{
			SendDlgItemMessage( dlg,IDC_COMBO,CB_ADDSTRING,
									0,(LPARAM)" (Auto-Detect)" );
			SendDlgItemMessage( dlg,IDC_COMBO,CB_SETITEMDATA,0,NULL );

			for( CTool* p=g_pToolList; p!=NULL; p=p->GetNext() )
			{
				int i=SendDlgItemMessage( dlg,IDC_COMBO,CB_ADDSTRING,
										0,(LPARAM)p->GetRoutineName() );
					  SendDlgItemMessage( dlg,IDC_COMBO,CB_SETITEMDATA,
										i,(LPARAM)p );
			}

			kiutil::wndFront( dlg );
			SendDlgItemMessage( dlg,IDC_COMBO,CB_SETCURSEL,0,0 );
			SetFocus( GetDlgItem(dlg,IDC_COMBO) );
		}
		return TRUE;

	case WM_COMMAND:
		if( LOWORD(wp)==IDOK )
		{
			int i=SendDlgItemMessage(dlg,IDC_COMBO,CB_GETCURSEL,0,0);
			EndDialog( dlg,
				SendDlgItemMessage( dlg,IDC_COMBO,CB_GETITEMDATA,i,0 ) );
		}
		return TRUE;
	}
	return FALSE;
}

// t@C ///////////////////////////////////////////////////
//    or [`mF ///////////////////////////////////////

class CInfoDlg // Ȃ󋵕\_CAO(
{
public:

	CInfoDlg( const char* fname, CTool* p )
		{
			// 󋵕\_CAOpf[^
			m_bFlagEnd = true;
			m_Han = NULL;
			strcpy( m_FName, fname );
			strcpy( m_RName,"XacRett: ");
			strcat( m_RName, p->GetRoutineName() );
		}

	void Start()
		{
			// ItOIt
			m_bFlagEnd = false;

			// Xbh쐬
			DWORD id;
			m_Han = CreateThread( NULL, 0, Thread, this,
									CREATE_SUSPENDED, &id);
			if( m_Han )
			{
				// 쐬ɐADx IDLE ɂăX^[g
				SetThreadPriority( m_Han, THREAD_PRIORITY_IDLE );
				ResumeThread( m_Han );
			}
			else
				// sAItO𗧂ĂĂ
				m_bFlagEnd=true;
		}

	~CInfoDlg()
		{
			// ItOĂȂꍇ
			if( !m_bFlagEnd )
			{
				// tO𗧂Ă
				m_bFlagEnd = true;

				// XbhI܂őҋ@
				for( DWORD ec=STILL_ACTIVE; ec==STILL_ACTIVE; )
				{
					if( !GetExitCodeThread( m_Han, &ec ) )
						break;
					Sleep(50);
				}

				// nh
				CloseHandle( m_Han );
			}
		}

private:
	char m_FName[300], m_RName[300];
	volatile bool m_bFlagEnd;
	volatile HANDLE m_Han;

	static DWORD WINAPI Thread( void* param )
		{
			HWND dlg = CreateDialogParam( GetModuleHandle(NULL),
										  MAKEINTRESOURCE(IDD_INFDLG),
										  NULL, Proc, (LPARAM)param );

			// ItOĂȂԃbZ[W[v
			for( MSG msg;
				 !((CInfoDlg*)param)->m_bFlagEnd;
				 PeekMessage(&msg,0,0,0,PM_REMOVE) )
			{
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}

			// ItOXbhI
			DestroyWindow( dlg );
			ExitThread( 0 );
			return 0;
		}

	static BOOL CALLBACK Proc( HWND dlg, UINT msg, WPARAM wp, LPARAM lp )
		{
			if( msg==WM_INITDIALOG )
			{
				CInfoDlg* p = (CInfoDlg*)lp;
				SetWindowLong( dlg,GWL_USERDATA,lp );
				SetWindowText( dlg,p->m_RName );
				SetWindowText( GetDlgItem(dlg,IDC_FNAME), p->m_FName );
				ShowWindow( dlg,SW_SHOW );
				UpdateWindow( dlg );
			}
			else if( (msg==WM_SYSCOMMAND && (wp==SC_CLOSE||wp==SC_DEFAULT))
					|| (msg==WM_COMMAND && LOWORD(wp)==IDCANCEL) )
				return TRUE;
			return FALSE;
		}
};

static void ProcessFile( char* fname, CTool* p, bool bCheckOnly )
{
	if( p==NULL )
	{
		// wb_ۂǍ
		FILE* fp=fopen( fname,"rb" );
		if( !fp )
		{
			g_nError[ NOT_A_FILE ]++;
			return;
		}

		int read = fread( CTool::common_buf,1,XACR_BUFSIZE,fp );
		fseek( fp,0,SEEK_END );
		int fsize = ftell( fp );
		fclose( fp );

		if( fsize>0 )
		{
			// ܂gqōiďɃ^Cv
			const char* ext=kiutil::pathExt( fname );

			CTool *e=NULL;
			if( stricmp(ext,"exe") )
			{
				for( e=g_pToolList; e!=NULL; e=e->GetNext() )
				{
					if( e->IsType(ext) )
					{
						if( e->Check( fname, fsize ) )
							p=e;
						break;
					}
				}
			}

			// ł߂ȂS
			if( p==NULL )
			{
				for( p=g_pToolList; p!=NULL; p=p->GetNext() )
					if( p!=e && p->Check( fname,fsize ) )
						break;
			}
		}
	}

	// LongFileName擾
	WIN32_FIND_DATA find;
	HANDLE h = FindFirstFile( fname,&find );
	if( h==INVALID_HANDLE_VALUE )
	{
		g_nError[ NOT_A_FILE ]++;
		return;
	}
	FindClose( h );

		// `FbN݂̂炱ŏI
		if( bCheckOnly )
		{
			char string[1000];
			if( p )
				sprintf( string,"OK: \"%s\" (by %s)",
							find.cFileName, p->GetRoutineName() );
			else
				sprintf( string,"Unsupported: \"%s\"", find.cFileName );

			MessageBox( NULL, string,
				"XacRett", MB_OK|MB_ICONINFORMATION|MB_TOPMOST );
			return;
		}

	// ΉɂG[
	if( p==NULL )
	{
		g_nError[ UNSUPPORTED ]++;
		return;
	}

	// ɖLongFileNameɒuĂ
	int y,dummy;
	kiutil::pathSplit( fname,&y,&dummy );
	char my_fname[MAX_PATH];
	strcpy( my_fname, fname );
	strcpy( &my_fname[y+1], find.cFileName );

	// 󋵕\_CAO
	CInfoDlg inf( find.cFileName, p );

	// łɃtH_B
	char my_ddir[MAX_PATH*2];
	strcpy( my_ddir, g_DestDir );
	if( *CharPrev( my_ddir, my_ddir+strlen(my_ddir) ) != '\\' )
		strcat( my_ddir, "\\" );
	if( g_bMake )
	{
		char* x;
		for( x=find.cFileName; *x!=0; x=CharNext(x) ) 
			if( *x=='.' )
				break;
		*x='\0';
		strcat( my_ddir, find.cFileName );
		strcat( my_ddir, "\\" );
	}
	kiutil::pathMakeAbs_no_dtv_check( my_ddir );

	// 𓀁I
	SetCurrentDirectory( my_ddir );
	if( g_bDlg )
		inf.Start();
	if( !p->Extract( my_fname, my_ddir ) )
	{
		g_nError[ FAILED ]++;
		return;
	}

	// 𓀐J
	if( g_bOpen )
	{
		char str[MAX_PATH+50] = "explorer \"";
		my_ddir[ strlen(my_ddir)-1 ]='\0';
		strcat( str, my_ddir );
		strcat( str, "\"" );
		WinExec( str,SW_SHOWDEFAULT );
	}
}

/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/

int APIENTRY WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, int )
{
// 

	kiutil::pathInit();
	CTool::AllocWorkSpace();

// [`[h

	// 񈳏kn
	g_pToolList =         new CTarTool;
	g_pToolList->AddTail( new CJakTool );
	g_pToolList->AddTail( new CCpioTool );
	g_pToolList->AddTail( new CQPakTool );
	// ƃ}gn( `FbN )
	g_pToolList->AddTail( new CYz1Tool );
	g_pToolList->AddTail( new CTgzTool );
	g_pToolList->AddTail( new CTbzTool );
	g_pToolList->AddTail( new CTaZTool );
	g_pToolList->AddTail( new CIsTool );
	g_pToolList->AddTail( new CMSCompressTool );
	g_pToolList->AddTail( new CCpioGzTool );
	g_pToolList->AddTail( new CCpioBzTool );
	g_pToolList->AddTail( new CCpioZTool );
	g_pToolList->AddTail( new CMacBinTool );
	g_pToolList->AddTail( new CDzTool );
	// ƃ}gn( `FbNx )
	g_pToolList->AddTail( new CBgaTool );
	g_pToolList->AddTail( new CLzhTool );
	g_pToolList->AddTail( new CZipTool );
	g_pToolList->AddTail( new CCabTool );
	g_pToolList->AddTail( new CRarTool );
	g_pToolList->AddTail( new CAceTool );
	g_pToolList->AddTail( new CGcaTool );
	g_pToolList->AddTail( new CHqxTool );
	g_pToolList->AddTail( new CArjTool );
	g_pToolList->AddTail( new CIshTool );
	g_pToolList->AddTail( new CImpTool );
	g_pToolList->AddTail( new CZooTool );
	g_pToolList->AddTail( new CCptTool );
	g_pToolList->AddTail( new CPitTool );
	// ĂƁ`n
	g_pToolList->AddTail( new CDmgTool );
	g_pToolList->AddTail( new CGzTool );
	g_pToolList->AddTail( new CBz2Tool );
	g_pToolList->AddTail( new CCompressZTool );
	g_pToolList->AddTail( new CRezTool );
	g_pToolList->AddTail( new CArcTool );
	g_pToolList->AddTail( new CZacTool );
	g_pToolList->AddTail( new CAsdTool );
	g_pToolList->AddTail( new CArgTool );
	g_pToolList->AddTail( new CPackzTool );
	g_pToolList->AddTail( new CFrzTool );
	g_pToolList->AddTail( new CCompactCTool );
	g_pToolList->AddTail( new CArTool );
	g_pToolList->AddTail( new CSplTool );
//	g_pToolList->AddTail( new CPmdTool );
	// قڊgqOnlyn
	g_pToolList->AddTail( new CYncTool );
	g_pToolList->AddTail( new CMimeTool );
	g_pToolList->AddTail( new CUueTool );
	g_pToolList->AddTail( new CXxeTool );
	g_pToolList->AddTail( new CSharTool );
	g_pToolList->AddTail( new CAtoBTool );
	g_pToolList->AddTail( new CBooTool );
	g_pToolList->AddTail( new CFishTool );
	g_pToolList->AddTail( new CBelTool );
	g_pToolList->AddTail( new CJamTool );

// ݒ[h

	// init@C쐬( A̕SaveɂĝŒ )
	char ininame[MAX_PATH];
	GetModuleFileName( NULL, ininame, MAX_PATH );
	int l = strlen( ininame );
	ininame[l-3]='I', ininame[l-2]='N', ininame[l-1]='I';

	// 𓀐fBNg
	GetPrivateProfileString( "xacr","Dir","",g_DestDir,MAX_PATH,ininame );
	if( g_DestDir[0]=='\0' )
	{
		ITEMIDLIST *pidl;
		SHGetSpecialFolderLocation( NULL, CSIDL_DESKTOPDIRECTORY, &pidl );
		SHGetPathFromIDList( pidl, g_DestDir );

		IMalloc* pMalloc;
		SHGetMalloc( &pMalloc );
		pMalloc->Free( pidl );
		pMalloc->Release();
	}

	// BݒR
	g_bOpen = (0!=GetPrivateProfileInt( "xacr","Open",1,ininame ));
	g_bMake = (0!=GetPrivateProfileInt( "xacr","Make",1,ininame ));
	g_bDlg  = (0!=GetPrivateProfileInt( "xacr","Dlg" ,1,ininame ));

// L[{[h͓ǂ݂Ƃ

	GetAsyncKeyState(VK_SHIFT); // Ȃ񂩂̃_~[Ă΂ȂƎXρc
	bool shift_pushed = ( 0!=(GetAsyncKeyState(VK_SHIFT)>>15) );
	bool  ctrl_pushed = ( 0!=(GetAsyncKeyState(VK_CONTROL)>>15) );

// R}hCȂ

	// ShiftĂ畜[`IʂőI΂
	CTool* def = NULL;
	if( shift_pushed && !ctrl_pushed )
	{
		def = (CTool*)DialogBox( hInst,
				MAKEINTRESOURCE(IDD_TYPE), NULL, TypeProc );
	}

	if( __argc<=1 )
	{
		// ΁Aݒ
		if( Configuration(g_DestDir) )
			WritePrivateProfileString( "xacr","Dir",g_DestDir,ininame );
	}
	else
	{
		// ΁A
		for( int i=1; i!=__argc; i++ )
		{
			if( GetFileAttributes( __argv[i] ) & FILE_ATTRIBUTE_DIRECTORY )
				g_nError[ NOT_A_FILE ]++;
			else
				ProcessFile( __argv[i], def, ctrl_pushed );
		}

		// ()G[
		if( g_nError[0] | g_nError[1] | g_nError[2] )
		{
			char errstr[1000];
			sprintf( errstr, " NOT_A_FILE: %d times\n"
							 "UNSUPPORTED: %d times\n"
							 "     FAILED: %d times\n"
						   ,g_nError[NOT_A_FILE]
						   ,g_nError[UNSUPPORTED]
						   ,g_nError[FAILED] );
			MessageBox( NULL, errstr, NULL, MB_OK );
		}
	}

// ``

	delete g_pToolList;
	CTool::FreeWorkSpace();

	return 0;
}
